import numpy as np
import math
import pandas as pd
def ant(city_count,city_condition):
    # Distance距离矩阵
    Distance = np.zeros((city_count, city_count))
    for i in range(city_count):
        for j in range(city_count):
            if i != j:
                Distance[i][j] = math.sqrt((city_condition[i][0] - city_condition[j][0]) ** 2 + (
                            city_condition[i][1] - city_condition[j][1]) ** 2)
            else:
                Distance[i][j] = 100000
    # 蚂蚁数量
    AntCount = city_count
    # 城市数量
    # 信息素
    alpha =7  # 信息素重要程度因子
    beta = 10 # 启发函数重要程度因子
    rho = 0.1  # 挥发速度
    iter = 0  # 迭代初始值
    MAX_iter =int(city_count*0.5)  # 最大迭代值
    Q = 1
    # 初始信息素矩阵，全是为1组成的矩阵
    pheromonetable = np.ones((city_count, city_count))
    for i in range(len(pheromonetable)):
        for j in range(len(pheromonetable)):
            pheromonetable[i,j]=Distance[0][-1]/Distance[0][j]+Distance[j][-1]
    # 候选集列表,存放100只蚂蚁的路径(一只蚂蚁一个路径),一共就Antcount个路径，一共是蚂蚁数量*31个城市数量
    candidate = np.zeros((AntCount, city_count)).astype(int)
    # path_best存放的是相应的，每次迭代后的最优路径，每次迭代只有一个值
    path_best = np.zeros((MAX_iter, city_count)).astype(int)
    # 存放每次迭代的最优距离
    distance_best = np.zeros(MAX_iter)
    # 倒数矩阵
    etable = 1.0 / Distance
    while iter < MAX_iter:
        candidate[:, 0] = 0
        length = np.zeros(AntCount)
        # second：选择下一个城市选择
        for i in range(AntCount):
            # 移除已经访问的第一个元素
            unvisit = list(range(city_count))  # 列表形式存储没有访问的城市编号
            visit = candidate[i, 0]  # 当前所在点,第i个蚂蚁在第一个城市
            unvisit.remove(visit)  # 在未访问的城市中移除当前开始的点
            unvisit.remove(len(city_condition) - 1)
            for j in range(1, city_count - 1):  # 访问剩下的city_count个城市，city_count次访问
                # 下一城市的概率函数
                tiao_num = 0
                tiao_nums = []
                for tiao in unvisit:
                    tiao_num = tiao_num + Distance[visit][tiao]
                for tiao1 in unvisit:
                    if Distance[visit][tiao1] < tiao_num / len(unvisit) * 1.2:
                        tiao_nums.append(tiao1)
                protrans = np.zeros(len(tiao_nums))  # 每次循环都更改当前没有访问的城市的转移概率矩阵1*30,1*29,1*28...
                for k in range(len(tiao_nums)):
                    # 计算当前城市到剩余城市的（信息素浓度^alpha）*（城市适应度的倒数）^beta
                    # etable[visit][unvisit[k]],(alpha+1)是倒数分之一，pheromonetable[visit][unvisit[k]]是从本城市到k城市的信息素
                    protrans[k] = np.power(pheromonetable[visit][tiao_nums[k]], alpha) * np.power(
                        etable[visit][tiao_nums[k]], beta)
                # 累计概率，轮盘赌选择
                cumsumprobtrans = (protrans / np.sum(protrans)).cumsum()
                cumsumprobtrans -= np.random.rand()
                # 求出离随机数产生最近的索引值
                # print(tiao_nums)
                k = tiao_nums[list(cumsumprobtrans > 0).index(True)]
                # 下一个访问城市的索引值
                candidate[i, j] = k
                unvisit.remove(k)
                length[i] += Distance[visit][k]
                visit = k  # 更改出发点，继续选择下一个到达点

            candidate[i, city_count - 1] = len(city_condition) - 1
            length[i] += Distance[visit][city_count - 1]  # 最后一个城市和第一个城市的距离值也要加进去
        """
        更新路径等参数
        """
        # 如果迭代次数为一次，那么无条件让初始值代替path_best,distance_best.
        if iter == 0:
            distance_best[iter] = length.min()
            path_best[iter] = candidate[length.argmin()].copy()
        else:
            # 如果当前的解没有之前的解好，那么当前最优还是为之前的那个值；并且用前一个路径替换为当前的最优路径
            if length.min() > distance_best[iter - 1]:
                distance_best[iter] = distance_best[iter - 1]
                path_best[iter] = path_best[iter - 1].copy()
            else:  # 当前解比之前的要好，替换当前解和路径
                distance_best[iter] = length.min()
                path_best[iter] = candidate[length.argmin()].copy()
        agr=np.argmin(length)
        """
            信息素的更新
        """
        # 信息素的增加量矩阵
        changepheromonetable = np.zeros((city_count, city_count))
        jinyinpheromonetable = np.zeros((city_count,city_count))
        for i in range(AntCount):
            for j in range(city_count - 1):
                # 当前路径比如城市23之间的信息素的增量：1/当前蚂蚁行走的总距离的信息素
                changepheromonetable[candidate[i, j]][candidate[i][j + 1]] += Q / length[i]
                # Distance[candidate[i, j]][candidate[i, j + 1]]
            # 最后一个城市和第一个城市的信息素增加量
            # changepheromonetable[candidate[i, j + 1]][candidate[i, 0]] += Q / length[i]
        #精英信息素更新：
        for j in range(city_count-1):
            jinyinpheromonetable[candidate[agr,j]][candidate[agr][j+1]]+=1/length[agr]
        # 信息素更新的公式：
        pheromonetable = (1 - rho) * pheromonetable + changepheromonetable+jinyinpheromonetable
        iter += 1
    return path_best[-1],distance_best[-1]



